module Elastics
  module ApiStubs

    # The following lines are autogenerated by Elastics.doc
    # Notice: :index and :type variables are always shown as nil (default), although they may be required by elasticsearch

    #  ########## Elastics.store ##########
    #
    #  API Name: Index API
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-index_.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  store:
    #  - PUT
    #  - "/<<index>>/<<type>>/<<id>>"
    #
    #
    #  Usage:
    #  Elastics.store :id    => id,   # required
    #                 :type  => nil,
    #                 :index => nil
    #
    #  Notice: You must pass the :data variable.
    #
    def self.store(*vars)
      ## this is a stub, used for reference
      super
    end
    # also aliased by: :put_store


    #  ########## Elastics.post_store ##########
    #
    #  API Name: Index API
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-index_.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  post_store:
    #  - POST
    #  - "/<<index>>/<<type>>"
    #
    #
    #  Usage:
    #  Elastics.post_store :index => nil,
    #                      :type  => nil
    #
    #  Notice: The id is assigned by elasticsearch; you must pass the :data variable.
    #
    def self.post_store(*vars)
      ## this is a stub, used for reference
      super
    end
    # also aliased by: :put_store


    #  ########## Elastics.get ##########
    #
    #  API Name: Get API
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-get.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  get:
    #  - GET
    #  - "/<<index>>/<<type>>/<<id>>"
    #
    #
    #  Usage:
    #  Elastics.get :id    => id,   # required
    #               :type  => nil,
    #               :index => nil
    #
    def self.get(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.get_source ##########
    #
    #  API Name: Get API
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-get.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  get_source:
    #  - GET
    #  - "/<<index>>/<<type>>/<<id>>/_source"
    #
    #
    #  Usage:
    #  Elastics.get_source :id    => id,   # required
    #                      :type  => nil,
    #                      :index => nil
    #
    def self.get_source(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.delete ##########
    #
    #  API Name: Delete API
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-delete.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  delete:
    #  - DELETE
    #  - "/<<index>>/<<type>>/<<id>>"
    #
    #
    #  Usage:
    #  Elastics.delete :id    => id,   # required
    #                  :type  => nil,
    #                  :index => nil
    #
    #  Notice: You must pass the :data variable.
    #
    def self.delete(*vars)
      ## this is a stub, used for reference
      super
    end
    # also aliased by: :remove


    #  ########## Elastics.update ##########
    #
    #  API Name: Update API
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-update.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  update:
    #  - POST
    #  - "/<<index>>/<<type>>/<<id>>/_update"
    #
    #
    #  Usage:
    #  Elastics.update :id    => id,   # required
    #                  :type  => nil,
    #                  :index => nil
    #
    #  Notice: You must pass script or doc and the other options as the :data variable.
    #
    def self.update(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.multi_get_ids ##########
    #
    #  API Name: Multi Get API
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-multi-get.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  multi_get_ids:
    #  - GET
    #  - "/<<index>>/<<type>>/_mget"
    #  - ids: "<< ids >>"
    #
    #
    #  Usage:
    #  Elastics.multi_get_ids :ids   => ids,  # required
    #                         :type  => nil,
    #                         :index => nil
    #
    #  Notice: You must pass the :ids array.
    #
    def self.multi_get_ids(*vars)
      ## this is a stub, used for reference
      super
    end
    # also aliased by: :multi_get


    #  ########## Elastics.multi_get_docs ##########
    #
    #  API Name: Multi Get API
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-multi-get.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  multi_get_docs:
    #  - GET
    #  - "/<<index>>/<<type>>/_mget"
    #  - docs: "<< docs >>"
    #
    #
    #  Usage:
    #  Elastics.multi_get_docs :docs  => docs,  # required
    #                          :type  => nil,
    #                          :index => nil
    #
    #  Notice: You must pass the :docs array.
    #
    def self.multi_get_docs(*vars)
      ## this is a stub, used for reference
      super
    end
    # also aliased by: :multi_get


    #  ########## Elastics.post_bulk_string ##########
    #
    #  API Name: Bulk API
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-bulk.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  post_bulk_string:
    #  - POST
    #  - "/_bulk"
    #  - "<< bulk_string >>"
    #
    #
    #  Usage:
    #  Elastics.post_bulk_string :bulk_string => bulk_string  # required
    #
    #  Notice: You must pass the :docs array.
    #
    def self.post_bulk_string(*vars)
      ## this is a stub, used for reference
      super
    end
    # also aliased by: :bulk


    #  ########## Elastics.termvectors ##########
    #  ------------------
    #  Elastics::Template::API
    #  ---
    #  termvectors:
    #  - POST
    #  - "/<<index>>/<<type>>/<<id>>/_termvectors"
    #
    #
    #  Usage:
    #  Elastics.termvectors :id    => id,   # required
    #                       :type  => nil,
    #                       :index => nil
    #
    def self.termvectors(*vars)
      ## this is a stub, used for reference
      super
    end
    # also aliased by: :termvector


    #  ########## Elastics.multi_termvectors ##########
    #
    #  API Name: Multi Termvectors API
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-multi-termvectors.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  multi_termvectors:
    #  - POST
    #  - "/<<index>>/<<type>>/_mtermvectors"
    #  - docs: "<<docs= ~ >>"
    #
    #
    #  Usage:
    #  Elastics.multi_termvectors :index => nil,
    #                             :type  => nil,
    #                             :docs  => nil
    #
    #  Notice: You must pass the docs array as the :docs variable or use the :data variable for the simplified request.
    #
    def self.multi_termvectors(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.search_shards ##########
    #
    #  API Name: Search Shards
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/search-shards.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  search_shards:
    #  - GET
    #  - "/<<index>>/<<type>>/_search_shards"
    #
    #
    #  Usage:
    #  Elastics.search_shards :index => nil,
    #                         :type  => nil
    #
    #  Notice: You can pass the parameters as the :params variable.
    #
    def self.search_shards(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.count ##########
    #
    #  API Name: Search Shards
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/search-count.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  count:
    #  - GET
    #  - "/<<index>>/<<type>>/_count"
    #
    #
    #  Usage:
    #  Elastics.count :index => nil,
    #                 :type  => nil
    #
    #  Notice: You must pass the query to validate as the :data variable. You can pass the parameters as the :params variable.
    #
    def self.count(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.search_exists ##########
    #
    #  API Name: Search Exists
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/search-exists.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  search_exists:
    #  - GET
    #  - "/<<index>>/<<type>>/<<id= ~ >>/_search/exists"
    #
    #
    #  Usage:
    #  Elastics.search_exists :index => nil,
    #                         :type  => nil,
    #                         :id    => nil
    #
    #  Notice: You must pass the query to validate as the :data variable. You can pass the parameters as the :params variable.
    #
    def self.search_exists(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.validate ##########
    #
    #  API Name: Validate
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/search-validate.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  validate:
    #  - GET
    #  - "/<<index>>/<<type>>/<<id= ~ >>/_validate/query"
    #
    #
    #  Usage:
    #  Elastics.validate :index => nil,
    #                    :type  => nil,
    #                    :id    => nil
    #
    #  Notice: You must pass the query to validate as the :data variable. You can pass the parameters as the :params variable.
    #
    def self.validate(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.explain ##########
    #
    #  API Name: Validate
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/search-explain.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  explain:
    #  - GET
    #  - "/<<index>>/<<type>>/<<id= ~ >>/_explain"
    #
    #
    #  Usage:
    #  Elastics.explain :index => nil,
    #                   :type  => nil,
    #                   :id    => nil
    #
    #  Notice: You must pass the query to explain as the :data variable. You can pass the parameters as the :params variable.
    #
    def self.explain(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.delete_percolator ##########
    #
    #  API Name: Percolator
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/search-percolate.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  delete_percolator:
    #  - DELETE
    #  - "/<<index>>/.percolator/<<id>>"
    #
    #
    #  Usage:
    #  Elastics.delete_percolator :id    => id,  # required
    #                             :index => nil
    #
    def self.delete_percolator(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.percolate ##########
    #
    #  API Name: Percolator
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/search-percolate.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  percolate:
    #  - GET
    #  - "/<<index>>/<<type>>/_percolate"
    #
    #
    #  Usage:
    #  Elastics.percolate :index => nil,
    #                     :type  => nil
    #
    #  Notice: You must pass the the document (and additional queries) as :data variable.
    #
    def self.percolate(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.percolate_count ##########
    #
    #  API Name: Percolator
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/search-percolate.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  percolate_count:
    #  - GET
    #  - "/<<index>>/<<type>>/_percolate/count"
    #
    #
    #  Usage:
    #  Elastics.percolate_count :index => nil,
    #                           :type  => nil
    #
    #  Notice: You must pass the the document (and additional queries) as :data variable.
    #
    def self.percolate_count(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.put_percolator ##########
    #
    #  API Name: Percolator
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/search-percolate.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  put_percolator:
    #  - PUT
    #  - "/<<index>>/.percolator/<<id>>"
    #
    #
    #  Usage:
    #  Elastics.put_percolator :id    => id,  # required
    #                          :index => nil
    #
    #  Notice: You must pass the the document (and additional queries) as :data variable.
    #
    def self.put_percolator(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.more_like_this ##########
    #
    #  API Name: More Like This
    #  API URL: http://www.elasticsearch.org/guide/en/elasticsearch/reference/current/search-more-like-this.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  more_like_this:
    #  - GET
    #  - "/<<index>>/<<type>>/<<id>>/_mlt"
    #
    #
    #  Usage:
    #  Elastics.more_like_this :id    => id,   # required
    #                          :type  => nil,
    #                          :index => nil
    #
    #  Notice: You can pass the search API as :data variable.
    #
    def self.more_like_this(*vars)
      ## this is a stub, used for reference
      super
    end
    # also aliased by: :mlt


    #  ########## Elastics.put_index ##########
    #
    #  API Name: Create Index
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-create-index.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  put_index:
    #  - PUT
    #  - "/<<index>>"
    #  - settings:
    #      number_of_shards: "<<number_of_shards= 5 >>"
    #      number_of_replicas: "<<number_of_replicas= 1 >>"
    #
    #
    #  Usage:
    #  Elastics.put_index :index              => nil,
    #                     :number_of_shards   => 5,
    #                     :number_of_replicas => 1
    #
    #  Notice: You can also pass the complete data structure as :data variable, so passing settings, mappings, warmers, aliases, ...
    #
    def self.put_index(*vars)
      ## this is a stub, used for reference
      super
    end
    # also aliased by: :create_index


    #  ########## Elastics.post_index ##########
    #
    #  API Name: Create Index
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-create-index.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  post_index:
    #  - POST
    #  - "/<<index>>"
    #  - settings:
    #      number_of_shards: "<<number_of_shards= 5 >>"
    #      number_of_replicas: "<<number_of_replicas= 1 >>"
    #
    #
    #  Usage:
    #  Elastics.post_index :index              => nil,
    #                      :number_of_shards   => 5,
    #                      :number_of_replicas => 1
    #
    #  Notice: You can also pass the complete data structure as :data variable, so passing settings, mappings, warmers, aliases, ...
    #
    def self.post_index(*vars)
      ## this is a stub, used for reference
      super
    end
    # also aliased by: :create_index


    #  ########## Elastics.delete_index ##########
    #
    #  API Name: Delete Index
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-delete-index.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  delete_index:
    #  - DELETE
    #  - "/<<index>>"
    #
    #
    #  Usage:
    #  Elastics.delete_index :index => nil
    #
    def self.delete_index(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.get_index ##########
    #
    #  API Name: Get Index
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-get-index.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  get_index:
    #  - GET
    #  - "/<<index>>/<<features= ~ >>"
    #
    #
    #  Usage:
    #  Elastics.get_index :index    => nil,
    #                     :features => nil
    #
    def self.get_index(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.indices_exists ##########
    #
    #  API Name: Indices Exists
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-exists.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  indices_exists:
    #  - HEAD
    #  - "/<<index>>"
    #
    #
    #  Usage:
    #  Elastics.indices_exists :index => nil
    #
    def self.indices_exists(*vars)
      ## this is a stub, used for reference
      super
    end
    # also aliased by: :index_exists, :exist?


    #  ########## Elastics.close_index ##########
    #
    #  API Name: Open/Close Index
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-open-close.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  close_index:
    #  - POST
    #  - "/<<index>>/_close"
    #
    #
    #  Usage:
    #  Elastics.close_index :index => nil
    #
    def self.close_index(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.open_index ##########
    #
    #  API Name: Open/Close Index
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-open-close.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  open_index:
    #  - POST
    #  - "/<<index>>/_open"
    #
    #
    #  Usage:
    #  Elastics.open_index :index => nil
    #
    def self.open_index(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.put_index_mapping ##########
    #
    #  API Name: Put Mappings
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-put-mapping.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  put_index_mapping:
    #  - PUT
    #  - "/<<index>>/_mapping/<<type>>"
    #  - "<<type>>":
    #      properties: "<<properties>>"
    #
    #
    #  Usage:
    #  Elastics.put_index_mapping :properties => properties,  # required
    #                             :type       => nil,
    #                             :index      => nil
    #
    def self.put_index_mapping(*vars)
      ## this is a stub, used for reference
      super
    end
    # also aliased by: :put_mappings


    #  ########## Elastics.get_index_mapping ##########
    #
    #  API Name: Get Mappings
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-get-mapping.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  get_index_mapping:
    #  - GET
    #  - "/<<index>>/_mapping/<<type>>"
    #
    #
    #  Usage:
    #  Elastics.get_index_mapping :index => nil,
    #                             :type  => nil
    #
    def self.get_index_mapping(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.get_field_mapping ##########
    #
    #  API Name: Get Field Mappings
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-get-field-mapping.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  get_field_mapping:
    #  - GET
    #  - "/<<index>>/_mapping/<<type>>/field/<<field>>"
    #
    #
    #  Usage:
    #  Elastics.get_field_mapping :field => field,  # required
    #                             :type  => nil,
    #                             :index => nil
    #
    def self.get_field_mapping(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.types_exists ##########
    #
    #  API Name: Types Exists
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-types-exists.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  types_exists:
    #  - HEAD
    #  - "/<<index>>/<<type>>"
    #
    #
    #  Usage:
    #  Elastics.types_exists :index => nil,
    #                        :type  => nil
    #
    def self.types_exists(*vars)
      ## this is a stub, used for reference
      super
    end
    # also aliased by: :type_exists


    #  ########## Elastics.delete_index_mapping ##########
    #
    #  API Name: Delete Mappings
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-delete-mapping.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  delete_index_mapping:
    #  - DELETE
    #  - "/<<index>>/<<type>>"
    #
    #
    #  Usage:
    #  Elastics.delete_index_mapping :index => nil,
    #                                :type  => nil
    #
    def self.delete_index_mapping(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.get_index_aliases ##########
    #
    #  API Name: Index Aliases
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-aliases.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  get_index_aliases:
    #  - GET
    #  - "/<<index>>/_aliases"
    #
    #
    #  Usage:
    #  Elastics.get_index_aliases :index => nil
    #
    def self.get_index_aliases(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.post_index_aliases ##########
    #
    #  API Name: Index Aliases
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-aliases.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  post_index_aliases:
    #  - POST
    #  - "/_aliases"
    #  - actions: "<<actions>>"
    #
    #
    #  Usage:
    #  Elastics.post_index_aliases :actions => actions  # required
    #
    #  Notice: This is the generic interface allowing all the options. You can pass the :actions array or the aliases API structure as the :data variable.
    #
    def self.post_index_aliases(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.delete_index_alias ##########
    #
    #  API Name: Index Aliases
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-aliases.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  delete_index_alias:
    #  - DELETE
    #  - "/<<index>>/_alias/<<alias>>"
    #
    #
    #  Usage:
    #  Elastics.delete_index_alias :alias => alias,  # required
    #                              :index => nil
    #
    def self.delete_index_alias(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.get_index_alias ##########
    #
    #  API Name: Index Aliases
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-aliases.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  get_index_alias:
    #  - GET
    #  - "/<<index>>/_alias/<<alias= '*' >>"
    #
    #
    #  Usage:
    #  Elastics.get_index_alias :index => nil,
    #                           :alias => "*"
    #
    def self.get_index_alias(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.put_index_alias ##########
    #
    #  API Name: Index Aliases
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-aliases.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  put_index_alias:
    #  - PUT
    #  - "/<<index>>/_alias/<<alias>>"
    #
    #
    #  Usage:
    #  Elastics.put_index_alias :alias => alias,  # required
    #                           :index => nil
    #
    #  Notice: This is the single index alias. You can pass other options as the :data variable.
    #
    def self.put_index_alias(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.update_index_settings ##########
    #
    #  API Name: Update Indices Settings
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-update-settings.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  update_index_settings:
    #  - PUT
    #  - "/<<index>>/_settings"
    #
    #
    #  Usage:
    #  Elastics.update_index_settings :index => nil
    #
    #  Notice: You can pass the settings structure as the :data variable.
    #
    def self.update_index_settings(*vars)
      ## this is a stub, used for reference
      super
    end
    # also aliased by: :put_index_settings


    #  ########## Elastics.get_index_settings ##########
    #
    #  API Name: Get Indices Settings
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-get-settings.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  get_index_settings:
    #  - GET
    #  - "/<<index>>/_settings"
    #
    #
    #  Usage:
    #  Elastics.get_index_settings :index => nil
    #
    def self.get_index_settings(*vars)
      ## this is a stub, used for reference
      super
    end
    # also aliased by: :get_settings


    #  ########## Elastics.analyze_index ##########
    #
    #  API Name: Analyze
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-analyze.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  analyze_index:
    #  - GET
    #  - "/<<index>>/_analyze"
    #
    #
    #  Usage:
    #  Elastics.analyze_index :index => nil
    #
    #  Notice: You can pass the text to analyze as the :data variable (or the param :text). You can pass the parameters as the :params variable.
    #
    def self.analyze_index(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.delete_index_template ##########
    #
    #  API Name: Index Templates
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-templates.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  delete_index_template:
    #  - DELETE
    #  - "/_template/<<template>>"
    #
    #
    #  Usage:
    #  Elastics.delete_index_template :template => template  # required
    #
    def self.delete_index_template(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.get_index_template ##########
    #
    #  API Name: Index Templates
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-templates.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  get_index_template:
    #  - GET
    #  - "/_template/<<template= ~ >>"
    #
    #
    #  Usage:
    #  Elastics.get_index_template :template => nil
    #
    def self.get_index_template(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.index_template_exists ##########
    #
    #  API Name: Index Templates
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-templates.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  index_template_exists:
    #  - HEAD
    #  - "/_template/<<template>>"
    #
    #
    #  Usage:
    #  Elastics.index_template_exists :template => template  # required
    #
    def self.index_template_exists(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.put_index_template ##########
    #
    #  API Name: Index Templates
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-templates.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  put_index_template:
    #  - PUT
    #  - "/_template/<<template>>"
    #
    #
    #  Usage:
    #  Elastics.put_index_template :template => template  # required
    #
    #  Notice: You must pass the template structure as the :data variable.
    #
    def self.put_index_template(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.delete_index_warmer ##########
    #
    #  API Name: Warmers
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-warmers.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  delete_index_warmer:
    #  - DELETE
    #  - "/<<index>>/_warmer/<<warmer>>"
    #
    #
    #  Usage:
    #  Elastics.delete_index_warmer :warmer => warmer,  # required
    #                               :index  => nil
    #
    def self.delete_index_warmer(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.put_index_warmer ##########
    #
    #  API Name: Warmers
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-warmers.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  put_index_warmer:
    #  - PUT
    #  - "/<<index>>/<<type>>/_warmer/<<warmer>>"
    #
    #
    #  Usage:
    #  Elastics.put_index_warmer :warmer => warmer,  # required
    #                            :type   => nil,
    #                            :index  => nil
    #
    #  Notice: You must pass the warmer structure as the :data variable.
    #
    def self.put_index_warmer(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.get_index_warmer ##########
    #
    #  API Name: Warmers
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-warmers.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  get_index_warmer:
    #  - GET
    #  - "/<<index>>/_warmer/<<warmer= ~ >>"
    #
    #
    #  Usage:
    #  Elastics.get_index_warmer :index  => nil,
    #                            :warmer => nil
    #
    def self.get_index_warmer(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.index_status ##########
    #
    #  API Name: Status
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-status.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  index_status:
    #  - GET
    #  - "/<<index>>/_status"
    #
    #
    #  Usage:
    #  Elastics.index_status :index => nil
    #
    def self.index_status(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.index_stats ##########
    #
    #  API Name: Stats
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-stats.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  index_stats:
    #  - GET
    #  - "/<<index>>/_stats/<<stats= ~ >>"
    #
    #
    #  Usage:
    #  Elastics.index_stats :index => nil,
    #                       :stats => nil
    #
    def self.index_stats(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.index_segments ##########
    #
    #  API Name: Segments
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-segments.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  index_segments:
    #  - GET
    #  - "/<<index>>/_segments"
    #
    #
    #  Usage:
    #  Elastics.index_segments :index => nil
    #
    def self.index_segments(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.index_recovery ##########
    #
    #  API Name: Recovery
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-recovery.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  index_recovery:
    #  - GET
    #  - "/<<index>>/_recovery"
    #
    #
    #  Usage:
    #  Elastics.index_recovery :index => nil
    #
    def self.index_recovery(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.index_clearcache ##########
    #
    #  API Name: Recovery
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-clearcache.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  index_clearcache:
    #  - POST
    #  - "/<<index>>/_cache/clear"
    #
    #
    #  Usage:
    #  Elastics.index_clearcache :index => nil
    #
    def self.index_clearcache(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.flush_index ##########
    #
    #  API Name: Flush
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-flush.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  flush_index:
    #  - POST
    #  - "/<<index>>/_flush"
    #
    #
    #  Usage:
    #  Elastics.flush_index :index => nil
    #
    #  Notice: You can pass the parameters as the :params variable.
    #
    def self.flush_index(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.synced_flush_index ##########
    #
    #  API Name: Synced Flush
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-synced-flush.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  synced_flush_index:
    #  - POST
    #  - "/<<index>>/_flush/synced"
    #
    #
    #  Usage:
    #  Elastics.synced_flush_index :index => nil
    #
    #  Notice: You can pass the parameters as the :params variable.
    #
    def self.synced_flush_index(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.refresh_index ##########
    #
    #  API Name: Refresh
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-refresh.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  refresh_index:
    #  - POST
    #  - "/<<index>>/_refresh"
    #
    #
    #  Usage:
    #  Elastics.refresh_index :index => nil
    #
    def self.refresh_index(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.optimize_index ##########
    #
    #  API Name: Optimize
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-optimize.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  optimize_index:
    #  - POST
    #  - "/<<index>>/_optimize"
    #
    #
    #  Usage:
    #  Elastics.optimize_index :index => nil
    #
    #  Notice: You can pass the parameters as the :params variable.
    #
    def self.optimize_index(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.upgrade_index ##########
    #
    #  API Name: Upgrade
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-upgrade.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  upgrade_index:
    #  - POST
    #  - "/<<index>>/_upgrade"
    #
    #
    #  Usage:
    #  Elastics.upgrade_index :index => nil
    #
    #  Notice: You can pass the parameters as the :params variable.
    #
    def self.upgrade_index(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.cat ##########
    #
    #  API Name: Cat API
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/cat.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  cat:
    #  - GET
    #  - "/"
    #
    #
    #  Usage:
    #  Elastics.cat
    #  Notice: You must pass the :path variable or you can pass it as a simple string argument: Elastics.cat('/path')
    #
    def self.cat(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.cluster_health ##########
    #
    #  API Name: Health
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/cluster-health.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  cluster_health:
    #  - GET
    #  - "/_cluster/health/<<index>>"
    #
    #
    #  Usage:
    #  Elastics.cluster_health :index => nil
    #
    #  Notice: You can pass the params as the :params variable.
    #
    def self.cluster_health(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.cluster_state ##########
    #
    #  API Name: State
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/cluster-state.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  cluster_state:
    #  - GET
    #  - "/_cluster/state/<<metrics= _all >>/<<index>>"
    #
    #
    #  Usage:
    #  Elastics.cluster_state :metrics => "_all",
    #                         :index   => nil
    #
    #  Notice: You can pass the metrics as the :metrics variable.
    #
    def self.cluster_state(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.cluster_stats ##########
    #
    #  API Name: Stats
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/cluster-stats.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  cluster_stats:
    #  - GET
    #  - "/_cluster/stats"
    #
    #
    #  Usage:
    #  Elastics.cluster_stats
    #  Notice: You can pass the params as the :params variable.
    #
    def self.cluster_stats(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.cluster_pending_tasks ##########
    #
    #  API Name: Pending Cluster Tasks
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/cluster-pending.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  cluster_pending_tasks:
    #  - GET
    #  - "/_cluster/pending_tasks"
    #
    #
    #  Usage:
    #  Elastics.cluster_pending_tasks
    #  Notice: You can pass the params as the :params variable.
    #
    def self.cluster_pending_tasks(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.cluster_reroute ##########
    #
    #  API Name: Cluster Reroute
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/cluster-reroute.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  cluster_reroute:
    #  - POST
    #  - "/_cluster/reroute"
    #
    #
    #  Usage:
    #  Elastics.cluster_reroute
    #  Notice: You must pass the data structure as the :data variable.
    #
    def self.cluster_reroute(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.get_cluster_settings ##########
    #
    #  API Name: Cluster Update Settings
    #  API URL: http://www.elasticsearch.org/guide/reference/api/admin-cluster-update-settings
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  get_cluster_settings:
    #  - GET
    #  - "/_cluster/settings"
    #
    #
    #  Usage:
    #  Elastics.get_cluster_settings
    def self.get_cluster_settings(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.put_cluster_settings ##########
    #
    #  API Name: Cluster Update Settings
    #  API URL: http://www.elasticsearch.org/guide/reference/api/admin-cluster-update-settings
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  put_cluster_settings:
    #  - PUT
    #  - "/_cluster/settings"
    #
    #
    #  Usage:
    #  Elastics.put_cluster_settings
    #  Notice: You must pass the data structure as the :data variable.
    #
    def self.put_cluster_settings(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.cluster_nodes_stats ##########
    #
    #  API Name: Nodes Stats
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/cluster-nodes-stats.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  cluster_nodes_stats:
    #  - GET
    #  - "/_nodes/<<nodes= ~ >>/stats/<<stats= ~ >>"
    #
    #
    #  Usage:
    #  Elastics.cluster_nodes_stats :nodes => nil,
    #                               :stats => nil
    #
    #  Notice: You can pass the params as the :params variable. You must pass the data structure as the :data variable.
    #
    def self.cluster_nodes_stats(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.cluster_nodes_info ##########
    #
    #  API Name: Nodes Info
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/cluster-nodes-info.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  cluster_nodes_info:
    #  - GET
    #  - "/_nodes/<<nodes= ~ >>/<<info= ~ >>"
    #
    #
    #  Usage:
    #  Elastics.cluster_nodes_info :nodes => nil,
    #                              :info  => nil
    #
    #  Notice: This template uses the _nodes shortcut.
    #
    def self.cluster_nodes_info(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.cluster_nodes_hot_threads ##########
    #
    #  API Name: Nodes Hot Threads
    #  API URL: https://www.elastic.co/guide/en/elasticsearch/reference/current/cluster-nodes-hot-threads.html
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  cluster_nodes_hot_threads:
    #  - GET
    #  - "/_nodes/<<nodes= ~ >>/hot_threads"
    #
    #
    #  Usage:
    #  Elastics.cluster_nodes_hot_threads :nodes => nil
    #
    def self.cluster_nodes_hot_threads(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.match_all ##########
    #
    #  API Name:
    #  API URL:
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  match_all:
    #  - GET
    #  - "/<<index>>/<<type>>/_search"
    #  - query:
    #      match_all: {}
    #
    #
    #  Usage:
    #  Elastics.match_all :index => nil,
    #                     :type  => nil
    #
    #  Notice: Not a real API method, but handy.
    #
    def self.match_all(*vars)
      ## this is a stub, used for reference
      super
    end


    #  ########## Elastics.search_by_id ##########
    #
    #  API Name:
    #  API URL:
    #
    #  -----------------------
    #  Elastics::Template::Api
    #  ---
    #  search_by_id:
    #  - GET
    #  - "/<<index>>/<<type>>/_search"
    #  - query:
    #      term:
    #        _id: "<<id>>"
    #
    #
    #  Usage:
    #  Elastics.search_by_id :id    => id,   # required
    #                        :type  => nil,
    #                        :index => nil
    #
    #  Notice: Get a document without using the get API and without raising any error if it is missing.
    #
    def self.search_by_id(*vars)
      ## this is a stub, used for reference
      super
    end

  end
end
